<?PHP
  require "./common.inc";
  
  if($num==0 || $ForumName==''){
    Header("Location: $forum_url?$GetVars");
    exit;
  }

  require "./bad_hosts.inc";
  if(!$host){
    $host = getenv('REMOTE_HOST');
  }
  if(!$host){
    $host = getenv('REMOTE_ADDR');    
  }
  
  $host = @GetHostByAddr($host);

  if(is_array($hosts)){
    $cnt=count($hosts);
    for($x=0;$x<$cnt;$x++){
      if(ereg($hosts[$x],$host)){
        Header("Location: $violation_page.$ext?num=$num&author=$author&email=$email&$GetVars");
        exit();
      }
    }
  }

  require "./bad_names.inc";
  if(is_array($names)){
    $cnt=count($names);
    for($x=0;$x<$cnt;$x++){
      if(strstr($author, $names[$x])){
        Header("Location: $violation_page.$ext?num=$num&author=$author&email=$email&$GetVars");
        exit();
      }
    }
  }

  require "./bad_emails.inc";
  if(is_array($emails)){
    $cnt=count($emails);
    for($x=0;$x<$cnt;$x++){
      if(strstr($email, $emails[$x])){
        Header("Location: $violation_page.$ext?num=$num&author=$author&email=$email&$GetVars");
        exit();
      }
    }  
  }
  
  if(!eregi(".+@.+\\..+", $email)  && $email!=$Password && $email!=$ModPass){
    $email="";
  }

  if(trim($author)==""){
    $IsError=$lNoAuthor;
  }
  if(trim($subject)==""){
    $IsError=$lNoSubject;
  }
  if(trim($body)==""){
    $IsError=$lNoBody;
  }
  if(trim($email)=="" && $email_reply){
    $IsError=$lNoEmail;
  }

  if($IsError || !$action){
    if(file_exists("header_$TableName.inc")){
      include "./header_$TableName.inc";    
    }
    else{
      include "./header.inc";
    }

    if(count($forums)>1){
      $nav = "<div class=nav><FONT color=\"$NavFontColor\"><a href=\"$forum_page.$ext?$GetVars\"><font color=\"$NavFontColor\">".$lForumList."</font></a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"$list_page.$ext?num=$num$GetVars\"><font color=\"$NavFontColor\">".$lGoToTop."</font></a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"$search_page.$ext?num=$num$GetVars\"><font color=\"$NavFontColor\">".$lSearch."</font></a>&nbsp;</font></div>";
    }
    else{
      $nav = "<div class=nav><FONT color=\"$NavFontColor\"><a href=\"$list_page.$ext?num=$num$GetVars\"><font color=\"$NavFontColor\">".$lGoToTop."</font></a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"$search_page.$ext?num=$num$GetVars\"><font color=\"$NavFontColor\">".$lSearch."</font></a>&nbsp;</font></div>";
    }

    include "./form.inc";
    if(file_exists("footer_$TableName.inc")){
      include "./footer_$TableName.inc";    
    }
    else{
      include "./footer.inc";
    }
    exit();
  }

  if(file_exists("censor_$TableName.inc")){
    include "./censor_$TableName.inc";    
  }
  else{
    include "./censor.inc";
  }

  $blurb = "@!#$";
  $cnt = count($profan);
  if ( $cnt > 0 ){
    $a=0;
    While($a<$cnt){
      $sWord = $profan[$a];

      if(strstr(strtoupper($author), strtoupper($sWord))){
        if(strtoupper($author)==strtoupper($sWord)) $author=$blurb;
        $author = eregi_replace("^$sWord([^a-zA-Z])", "$blurb\\1", $author);
        $author = eregi_replace("([^a-zA-Z])$sWord$", "\\1$blurb", $author);
        while(eregi("([^a-zA-Z])($sWord)([^a-zA-Z])", $author)){
          $author = eregi_replace("([^a-zA-Z])($sWord)([^a-zA-Z])", "\\1$blurb\\3", $author);
        }
      }
      if(strstr(strtoupper($subject), strtoupper($sWord))){
        if(strtoupper($subject)==strtoupper($sWord)) $subject=$blurb;
        $subject = eregi_replace("^$sWord([^a-zA-Z])", "$blurb\\1", $subject);
        $subject = eregi_replace("([^a-zA-Z])$sWord$", "\\1$blurb", $subject);
        while(eregi("([^a-zA-Z])($sWord)([^a-zA-Z])", $subject)){
          $subject = eregi_replace("([^a-zA-Z])($sWord)([^a-zA-Z])", "\\1$blurb\\3", $subject);
        }
      }
      if(strstr(strtoupper($email), strtoupper($sWord))){
        if(strtoupper($email)==strtoupper($sWord)) $email="";
        $email = eregi_replace("^$sWord([^a-zA-Z])", "$blurb\\1", $email);
        $email = eregi_replace("([^a-zA-Z])$sWord$", "\\1$blurb", $email);
        while(eregi("([^a-zA-Z])($sWord)([^a-zA-Z])", $email)){
          $email = eregi_replace("([^a-zA-Z])($sWord)([^a-zA-Z])", "\\1$blurb\\3", $email);
        }
      }
      if(strstr(strtoupper($body), strtoupper($sWord))){
        if(strtoupper($body)==strtoupper($sWord)) $body=$blurb;
        $body = eregi_replace("^$sWord([^a-zA-Z])", "$blurb\\1", $body);
        $body = eregi_replace("([^a-zA-Z])$sWord$", "\\1$blurb", $body);
        while(eregi("([^a-zA-Z])($sWord)([^a-zA-Z])", $body)){
          $body = eregi_replace("([^a-zA-Z])($sWord)([^a-zA-Z])", "\\1$blurb\\3", $body);
        }
      }
      $a++;
    }
  }

  if($UseCookies){
    $name_cookie="phorum_name_$TableName";
    $email_cookie="phorum_email_$TableName";

    if((!IsSet($$name_cookie)) || ($$name_cookie != $author)) {
      SetCookie("phorum_name_$TableName",$author,time()+ 31536000);
    }
    if((!IsSet($$email_cookie)) || ($$email_cookie != $email)) {
      SetCookie("phorum_email_$TableName",$email,time()+ 31536000);
    }
  }
  
  $author = stripslashes($author);
  $email = stripslashes($email);
  $subject = stripslashes($subject);
  $body = stripslashes($body);  

  $author = str_replace("'", "\\'", $author);
  $email = str_replace("'", "\\'", $email);
  $subject = str_replace("'", "\\'", $subject);
  $body = str_replace("'", "\\'", $body);  

  $datestamp = date("Y-m-d H:i:s");
  $author = htmlspecialchars($author);
  $email = htmlspecialchars($email);
  $subject = htmlspecialchars($subject);

  if(($email==$ModPass && $ModPass!="") || ($email==$Password && $Password!="")){
    $email=$Mod;
    $author = "<b>$author</b>";
    $subject = "<b>$subject</b>";      
    $body="<HTML>$body</HTML>";
    $host="<b>$StaffHost</b>";
  }
  else{
    $body=eregi_replace("</*HTML>", "", $body);
    if($AllowHtml){
      $body="<HTML>$body</HTML>";
    }
  }

  $id=$DB->nextid($TableName);
  
  if($id==0){
    echo "Error getting nextval.";
    exit();
  }

  if($thread==0){
    $thread=$id;
  }
  else{
    $more = $thread+1;
    $more = "&action=-1&thread=$more";
  }

  $sSQL = "Insert Into $BodiesTable values ($id, '$body', '$thread')";

  $q->query($DB, $sSQL);

  if(!$q->result){
    echo $q->error()."<br>$sSQL";
    exit();
  }

  $sSQL = "Insert Into $TableName (id, author, email, datestamp, subject, host, thread, parent, email_reply) values ('$id', '$author', '$email', '$datestamp', '$subject', '$host', '$thread', '$parent', '$email_reply')";

  $q->query($DB, $sSQL);

  if($EmailModerator==1){
    mail($Mod, "Moderate for $ForumName.  Message: $id.", "Subject: ".stripslashes($subject)."\n$forum_url/$read_page.$ext?num=$num&id=$id&thread=$thread\n\n".undo_htmlspecialchars(stripslashes($body)), "From: Phorum <$Mod>");
  }

  if($thread!=0){

    $sSQL = "Select distinct email from $TableName where thread=$thread and email_reply='Y' and email<>'$email'";

    $q->query($DB, $sSQL);

    $BCC="";
    if($q->numrows()>0){
  	  while($row=$q->getrow()){
        $BCC.=$row["email"].",";
      }
      $BCC=substr($BCC, 0, strlen($BCC)-1);
      mail("", "[$ForumName] $subject [$num:$thread:$id]","$forum_url/$read_page.$ext?num=$num&id=$id&thread=$thread\n\n".undo_htmlspecialchars(stripslashes($body)), "From: $author <$email>\nBCC: $BCC");
    }
  }

  Header ("Location: $forum_url/$list_page.$ext?num=$num$more$GetVars");

?>