<?PHP
////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//   Copyright (C) 1998  Phorum Development Team                              //
//   http://www.phorum.org                                                    //
//                                                                            //
//   This program is free software. You can redistribute it and/or modify     //
//   it under the terms of the GNU General Public License Version 2as         //
//   published by the Free Software Foundation.                               //
//                                                                            //
//   This program is distributed in the hope that it will be useful,          //
//   but WITHOUT ANY WARRANTY, without even the implied warranty of           //
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//   GNU General Public License for more details.                             //
//                                                                            //
//   You should have received a copy of the GNU General Public License        //
//   along with this program; if not, write to the Free Software              //
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

  error_reporting(1023); 

  $phorumver="3.0.7";

  function undo_htmlspecialchars($string){

    str_replace("&amp;", "&", $string);
    str_replace("&quot;", "\"", $string);
    str_replace("&lt;", "<", $string);
    str_replace("&gt;", ">", $string);
 
    return $string;
  }

	function htmlencode($string){
		$ret_string="";
		$len=strlen($string);
		for($x=0;$x<$len;$x++){
			$ord=ord(substr($string, $x, 1));
			$ret_string .= "&#$ord;";
		}
		return $ret_string;
	}
	
	function htmldecode($string){
		$ret_string="";
		$arr=explode("&#", $string);
		$count=count($arr);
		$x=1; //ignore first element. it will be ""
		while($x<$count){
			$asc=ereg_replace("(.*);", "\\1", $arr[$x]);
			$chr = chr($asc);
			$ret_string .= $chr;
			$x++;
		}		
		return $ret_string;
	}

  function my_nl2br($str){
    return ereg_replace("([^>])\n","\\1<BR>\n",$str);
  }

  function bgcolor($color){
    if($color!=""){
      return " bgcolor=\"".$color."\"";
    }
    else{
      return'';
    }
  }

  // variable initialization
  
  function initvar($varname){
    global $$varname;
    if(!isset($$varname))
      $$varname='';
  }
  
  initvar("action");
  initvar("admin");
  initvar("AllowHtml");
  initvar("author");
  initvar("body");
  initvar("bodies");
  initvar("BodiesTable");
  initvar("collapsed");
  initvar("Collapsed");
  initvar("description");
  initvar("Description");
  initvar("down");
  initvar("email");
  initvar("emails");
  initvar("email_mod");
  initvar("email_reply");
  initvar("EmailModerator");
  initvar("err");
  initvar("first_active");
  initvar("forum");
  initvar("ForumLang");
  initvar("ForumName");
  initvar("forums");
  initvar("GetVars");
  initvar("haveread");
  initvar("html");
  initvar("host");
  initvar("hosts");
  initvar("id");
  initvar("inclause");
  initvar("IsError");
  initvar("key");
  initvar("lang");
  initvar("loc");
  initvar("MagicQuotes");
  initvar("max");
  initvar("message");
  initvar("min");
  initvar("mod");
  initvar("Mod");
  initvar("ModPass");
  initvar("more");
  initvar("multi_level");
  initvar("MultiLevel");
  initvar("name");
  initvar("names");
  initvar("nav_color");
  initvar("nav_font_color");
  initvar("NavColor");
  initvar("NavFontColor");
  initvar("new_UseCookies");
  initvar("new_sortforums");
  initvar("nRows");
  initvar("num");
  initvar("old_message");
  initvar("option");
  initvar("parent");
  initvar("p_author");
  initvar("p_body");
  initvar("p_subject");
  initvar("PostVars");
  initvar("qauthor");
  initvar("qbody");
  initvar("qsubject");
  initvar("quote");
  initvar("quote_button");
  initvar("read");
  initvar("sortforums");
  initvar("staff_host");
  initvar("StaffHost");
  initvar("start_num");
  initvar("step");
  initvar("subject");
  initvar("table");
  initvar("table_body_color_1");
  initvar("table_body_color_2");
  initvar("table_body_font_color_1");
  initvar("table_body_font_color_2");
  initvar("table_header_color");
  initvar("table_header_font_color");
  initvar("table_exists");
  initvar("table_width");
  initvar("TableBodyColor1");
  initvar("TableBodyColor2");
  initvar("TableBodyFontColor1");
  initvar("TableBodyFontColor2");
  initvar("TableHeaderFontColor");
  initvar("TableHeaderColor");
  initvar("TableName");
  initvar("TableWidth");
  initvar("tcount");
  initvar("thread");
  initvar("threadtotal");
  initvar("title");
  initvar("type");  
  initvar("UseCookies");  

  // GET And POST site variables

  function AddGetVar($var, $value){
    GLOBAL $GetVars;
    $var=urlencode($var);
    $value=urlencode($value);
    $GetVars.="&";
    $GetVars.="$var=$value";
  }
  
  function AddPostVar($var, $value){
    GLOBAL $PostVars;
    $PostVars.="<input type=\"hidden\" name=\"$var\" value=\"$value\">\n";        
  }

  // If you have dynamic vars for GET and POST to pass on:
  //AddGetVar("dummy", $dummy);  
  // AddPostVar("session", $session);  
  
  // include abstraction layer.
  
  include "./abstract.php3";
  
  // set path to and include forums.inf

  $inf_path="./";  // requires ending slash
  
  $inf_file="$inf_path"."forums.inf";
  $inf_back="$inf_path"."forums.bak.inf";
  
  include "$inf_file";

?>