<?PHP
////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//   Copyright (C) 1998  Phorum Development Team                              //
//   http://www.phorum.org                                                    //
//                                                                            //
//   This program is free software. You can redistribute it and/or modify     //
//   it under the terms of the GNU General Public License Version 2as         //
//   published by the Free Software Foundation.                               //
//                                                                            //
//   This program is distributed in the hope that it will be useful,          //
//   but WITHOUT ANY WARRANTY, without even the implied warranty of           //
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//   GNU General Public License for more details.                             //
//                                                                            //
//   You should have received a copy of the GNU General Public License        //
//   along with this program; if not, write to the Free Software              //
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

  require "./common.inc";  

  $cutoff = 800; // See the faq.

  if($num==0 || $ForumName==''){
    Header("Location: $forum_url?$GetVars");
    exit;
  }

  $phcollapse="phorum-collapse-$TableName";
  $new_cookie="phorum-new-$TableName";
  $haveread_cookie="phorum-haveread-$TableName";

  if($UseCookies){
 
    if(IsSet($$new_cookie)){
      $old_message=$$new_cookie;
    }
    else{
      $old_message="0";
    }

    if(IsSet($$haveread_cookie)) {
      $haveread=unserialize(urldecode($$haveread_cookie));
    }
    else{
      $haveread[0]=$old_message;
    }

    if(IsSet($collapse)){
      $$phcollapse=$collapse;
      SetCookie("phorum-collapse-$TableName",$collapse,time()+ 31536000);
    }
    elseif(!isset($$phcollapse)){
      $$phcollapse=$Collapsed;
    } 
    if(!IsSet($$haveread_cookie)) {
       SetCookie("phorum-haveread-$TableName",urlencode(serialize($haveread)),0);
    }
    else{
       $$haveread_cookie="";
    }
  }
  else{
    if(IsSet($collapse)){
      $$phcollapse=$collapse;
    } 
    else{
      $$phcollapse=$Collapsed;
    }
  }
  
  if($DB->type=="postgresql"){
    $limit="";
    $q->query($DB, "set QUERY_LIMIT TO '$nDisplay'");
  }
  else{
    $limit=" limit $nDisplay";
  }

  if($thread==0 || $action==0){
    $sSQL = "Select max(thread) as thread from $TableName";
    $q->query($DB, $sSQL);
    if($q->numrows()>1){
      $maxthread=$q->field("thread", 0);
    }
    else{
      $maxthread=0;
    }
    $cutoff_thread=$maxthread-$cutoff;
    if($$phcollapse==0){
      $sSQL = "Select thread from $TableName where thread > $cutoff_thread order by thread desc".$limit;
    }
    else{
      $sSQL = "Select thread, count(*) as tcount, max(datestamp) as latest, max(id) as maxid from $TableName where thread > $cutoff_thread group by thread order by thread desc".$limit;
      echo "<!--$sSQL-->\n";
    }
  }
  else{
    if($action==1){
      $cutoff_thread=$thread+$cutoff;
      $sSQL = "Select thread from $TableName where thread < $cutoff_thread and thread > $thread order by thread".$limit;
      $q=new query($DB, $sSQL);
      if($rows=$q->numrows()){
        $thread = $q->field("thread",$rows-1);
      }
      $thread=$thread+1;
    }    
    $cutoff_thread=$thread-$cutoff;
    if($$phcollapse==0){
      $sSQL = "Select thread from $TableName where thread < $thread and thread > $cutoff_thread order by thread desc".$limit;
    }
    else{
      $sSQL = "Select thread, count(*) as tcount, max(datestamp) as latest, max(id) as maxid from $TableName  where thread < $thread and thread > $cutoff_thread group by thread order by thread desc".$limit;
      echo "<!--$sSQL-->\n";
    }
  }
  $thread_list = new query($DB, $sSQL);
  if($DB->type=="postgresql"){
    $q->query($DB, "set QUERY_LIMIT TO '0'");
  }
  $rows = $thread_list->numrows();
    if($rows==0 && $action!=0){
      Header("Location: $list_page.$ext?num=$num$GetVars");
      exit();
  }

  echo "<!--\n";
  $max = $thread_list->field("thread", 0);
  $min = $thread_list->field("thread", $rows-1);
  echo "-->\n";

  if($$phcollapse==0){
    $sSQL = "Select id,parent,thread,subject,author,datestamp from $TableName where thread<=$max and thread>=$min order by thread desc, id asc";
  }
  else{
    $sSQL = "Select id,parent,thread,subject,author,datestamp from $TableName where thread<=$max and thread>=$min and thread=id order by thread desc";
  }
  echo "<!--$sSQL-->\n";
  $msg_list = new query($DB, $sSQL);
  
  if(file_exists("header_$TableName.inc")){
    include "./header_$TableName.inc";    
  }
  else{
    include "./header.inc";
  }

  if($$phcollapse==0){
    $collapse_link = "<a href=\"$list_page.$ext?num=$num&collapse=1$GetVars\"><FONT color='$NavFontColor'>".$lCollapseThreads."</font></a>";
  }
  else{
    $collapse_link = "<a href=\"$list_page.$ext?num=$num&collapse=0$GetVars\"><FONT color='$NavFontColor'>".$lViewThreads."</font></a>";    
  }

  if(count($forums)>1){
    $nav = "<div class=nav><FONT color='$NavFontColor'>&nbsp;<a href=\"$forum_page.$ext?$GetVars\"><FONT color='$NavFontColor'>".$lForumList."</font></a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"$list_page.$ext?num=$num$GetVars\"><FONT color='$NavFontColor'>".$lGoToTop."</font></a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"$post_page.$ext?num=$num$GetVars\"><FONT color='$NavFontColor'>".$lStartTopic."</font></a>&nbsp;&nbsp;|&nbsp;&nbsp;$collapse_link&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"$search_page.$ext?num=$num$GetVars\"><FONT color='$NavFontColor'>".$lSearch."</font></a>&nbsp;</font></div>";
  }
  else{
    $nav = "<div class=nav><FONT color='$NavFontColor'>&nbsp;<a href=\"$list_page.$ext?num=$num$GetVars\"><FONT color='$NavFontColor'>".$lGoToTop."</font></a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"$post_page.$ext?num=$num$GetVars\"><FONT color='$NavFontColor'>".$lStartTopic."</font></a>&nbsp;&nbsp;|&nbsp;&nbsp;$collapse_link&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"$search_page.$ext?num=$num$GetVars\"><FONT color='$NavFontColor'>".$lSearch."</font></a>&nbsp;</font></div>";
  }


?>
<table width="<?PHP echo $TableWidth; ?>" cellspacing="0" cellpadding="3" border="0">
<tr>
    <td width="100%" align="right" valign="bottom" nowrap <?PHP echo bgcolor($NavColor); ?>><?PHP echo $nav; ?></td>
</tr>
</table>
<?PHP
  if(!$MultiLevel || $$phcollapse){
    include "./threads.inc";
  }
  else{
    include "./multi-threads.inc";
  }
?>
<table width="<?PHP echo $TableWidth; ?>" cellspacing="0" cellpadding="3" border="0">
<tr>
  <td width="60%" nowrap <?PHP echo bgcolor($NavColor); ?>><?PHP echo $nav; ?></td>
  <td align="right" width="40%" <?PHP echo bgcolor($NavColor); ?>><div class=nav><FONT color='<?PHP echo $NavFontColor; ?>'>&nbsp;<a href="<?PHP echo "$list_page.$ext"; ?>?num=<?PHP echo $num; ?>&thread=<?PHP echo $max; ?>&action=1&<?PHP echo $GetVars; ?>"><FONT color='<?PHP echo $NavFontColor; ?>'><?PHP echo $lNewerMessages;?></font></a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href="<?PHP echo "$list_page.$ext"; ?>?num=<?PHP echo $num; ?>&thread=<?PHP echo $min; ?>&action=-1&<?PHP echo $GetVars; ?>"><FONT color='<?PHP echo $NavFontColor; ?>'><?PHP echo $lOlderMessages;?></font></a>&nbsp;</font></div></td>
</tr>
</table>
<?PHP
  if(file_exists("footer_$TableName.inc")){
    include "./footer_$TableName.inc";    
  }
  else{
    include "./footer.inc";
  }
?>